package com.huimv.cattle.controller;


import com.huimv.cattle.service.OutStockService;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-12-15
 */
@CrossOrigin
@RestController
@RequestMapping("/v1.0.0/out-stock")
public class OutStockController {
    @Autowired
    private OutStockService outStockService;

    @PostMapping("/getOutStock")
    public Result getList(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return outStockService.listOutStock(httpServletRequest,paramsMap);
    }

    @PostMapping("/saveOutStock")
    public Result addOutStock(HttpServletRequest httpServletRequest, @RequestBody Map<String,String> paramsMap) {
        return outStockService.addOutStock(httpServletRequest,paramsMap);
    }

    @PostMapping("/deleteOutStock")
    public Result delete(@RequestBody Map<String,String> paramsMap) {
        String ids = paramsMap.get("ids");
        String[] id=ids.split(",");
        for (String s : id) {
            outStockService.removeById(s);
        }
        return new Result(ResultCode.SUCCESS,"删除成功");
    }
}

