package com.huimv.cattle.controller;


import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.cattle.pojo.PreventDetection;
import com.huimv.cattle.pojo.SalesCattle;
import com.huimv.cattle.pojo.vo.SalesCattleVo;
import com.huimv.cattle.service.SalesCattleService;
import com.huimv.cattle.utils.FarmCodeUtils;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author zn
 * @since 2022-12-15
 */
@CrossOrigin
@RestController
@RequestMapping("/v1.0.0/salesCattle")
public class SalesCattleController {
    @Autowired
    private SalesCattleService salesCattleService;

    @Transactional
    @PostMapping("/saveSalesCattle")
    public Result add(@RequestBody SalesCattleVo salesCattleVo, HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(salesCattleVo.getFarmCode(), request);
        List<SalesCattle> salesCattles = salesCattleVo.getSalesCattles();
        salesCattleService.remove(new QueryWrapper<SalesCattle>().eq("farm_code",farmCode));
        System.out.println(farmCode);
        for (SalesCattle salesCattle : salesCattles) {
            salesCattle.setFarmCode(farmCode);
            salesCattleService.save(salesCattle);
        }
        return new Result(10000,"添加成功",true);
    }
    @PostMapping("/updateSalesCattle")
    public  Result update(@RequestBody SalesCattle salesCattle){
        salesCattleService.updateById(salesCattle);
        return new Result(10000,"修改成功",true);
    }
    @PostMapping("/deleteSalesCattle")
    public  Result delete(@RequestBody Map<String,String> paramMap){
        String ids = paramMap.get("ids");
        String[] split = ids.split(",");
        for (String s : split) {
            salesCattleService.removeById(s);
        }
        return new Result(10000,"删除成功",true);
    }
    @PostMapping("/getSalesCattle")
    public  Result list(@RequestBody SalesCattle salesCattle,HttpServletRequest request){
        String farmCode = FarmCodeUtils.getFarmCode(salesCattle.getFarmCode(), request);
        List<SalesCattle> list = salesCattleService.list(new QueryWrapper<SalesCattle>().eq("farm_code",farmCode).orderByDesc("year").orderByDesc("quarter"));
        if (ObjectUtil.isEmpty(list)){
            return new Result(ResultCode.SUCCESS,new ArrayList<>());
        }
        return new Result(ResultCode.SUCCESS,list);
    }
}

